set(MANIFEST "${CMAKE_CURRENT_BINARY_DIR}/install_manifest.txt")

if(NOT EXISTS ${MANIFEST})
    message(FATAL_ERROR "Cannot find install manifest: '${MANIFEST}'")
endif()

file(STRINGS ${MANIFEST} files)
foreach(file ${files})
    file(GLOB parent_content ${file}/* ${file}/.*)
    list(LENGTH parent_content parent_len)
    while(parent_len EQUAL 0)
	message(STATUS "Removing: '${file}'")
	file(REMOVE_RECURSE ${file})
	if(EXISTS ${file})
	    MESSAGE(STATUS "'${file}' not removed")
	endif()
	get_filename_component(file ${file} DIRECTORY)
	file(GLOB parent_content ${file}/* ${file}/.*)
	list(LENGTH parent_content parent_len)
    endwhile()

endforeach(file)
