#include <crdb.h>
#include <iostream>

int main(int argc, char* argv[]) {

    std::string num, den;
    num = argv[1];
    den = argc > 2 ? argv[2] : "";
    CRRequest req{num, den};

    CRDataset ds;
    req.fetch(ds, "cached_crdata");

    for (auto pd : ds) {
        auto& d = *pd;
        std::cout << "exp:\t" << d.experiment << std::endl;
        std::cout << "time:\t" << d.time << std::endl;
        std::cout << "cite:\t" << d.cite << std::endl;
        std::cout << "link:\t" << d.link << std::endl;
        std::cout << "x:\t" << d.x_quantity << " [ " << d.x_unit << " ]"
                  << std::endl;
        std::cout << "y:\t" << d.y_quantity << " [ " << d.y_unit << " ]"
                  << std::endl;
        std::cout << "scale:\t" << d.scale << std::endl;
        std::cout << "hasbin:\t" << d.has_bin << std::endl;
        std::cout << "skewed:\t" << d.skewed_error << std::endl;
        std::cout << "rig:\t" << d.use_rigidity << std::endl;
        std::cout << "phi:\t" << d.phi << std::endl;
        std::cout << "dist:\t" << d.solar_dist << std::endl;
        std::cout << std::scientific;
        std::cout << "#x\t\t#y\t\t#ey1\t\t#ey2\t\t#x_lower\t#x_upper" << std::endl;
        for (const auto& dp : d) {
            std::cout << dp.x << '\t' << dp.y << '\t'             //
                      << dp.ey1 << '\t' << dp.ey2 << '\t'         //
                      << dp.x_lower << '\t' << dp.x_upper << '\t' //
                      << std::endl;
        }
        std::cout << "total:\t" << d.size() << std::endl;
    }

    return 0;
}
